// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"
	io "io"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// StateVersion is an autogenerated mock type for the StateVersion type
type StateVersion struct {
	mock.Mock
}

// CreateStateVersion provides a mock function with given fields: ctx, input
func (_m *StateVersion) CreateStateVersion(ctx context.Context, input *types.CreateStateVersionInput) (*types.StateVersion, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.StateVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateStateVersionInput) (*types.StateVersion, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateStateVersionInput) *types.StateVersion); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.StateVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateStateVersionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DownloadStateVersion provides a mock function with given fields: ctx, input, writer
func (_m *StateVersion) DownloadStateVersion(ctx context.Context, input *types.DownloadStateVersionInput, writer io.WriterAt) error {
	ret := _m.Called(ctx, input, writer)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DownloadStateVersionInput, io.WriterAt) error); ok {
		r0 = rf(ctx, input, writer)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetStateVersion provides a mock function with given fields: ctx, input
func (_m *StateVersion) GetStateVersion(ctx context.Context, input *types.GetStateVersionInput) (*types.StateVersion, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.StateVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetStateVersionInput) (*types.StateVersion, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetStateVersionInput) *types.StateVersion); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.StateVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetStateVersionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewStateVersion interface {
	mock.TestingT
	Cleanup(func())
}

// NewStateVersion creates a new instance of StateVersion. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewStateVersion(t mockConstructorTestingTNewStateVersion) *StateVersion {
	mock := &StateVersion{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
